Ext.data.Model
Alternate names
Ext.data.RecordHierarchy
Ext.BaseExt.data.ModelMixins
Requires
Subclasses
Files
A Model represents some object that your application manages. For example, one might define a Model for Users, Products, Cars, or any other real-world object that we want to model in the system. Models are registered via the model manager, and are used by stores, which are in turn used by many of the data-bound components in Ext.
Models are defined as a set of fields and any arbitrary methods and properties relevant to the model. For example:
Ext.define('User', {
extend: 'Ext.data.Model',
fields: [
{name: 'name', type: 'string'},
{name: 'age', type: 'int', convert: null},
{name: 'phone', type: 'string'},
{name: 'alive', type: 'boolean', defaultValue: true, convert: null}
],
changeName: function() {
var oldName = this.get('name'),
newName = oldName + " The Barbarian";
this.set('name', newName);
}
});
The fields array is turned into a MixedCollection automatically by the ModelManager, and all other functions and properties are copied to the new Model's prototype.
By default, the built in numeric and boolean field types have a (@link Ext.data.Field.convert} function which coerces string values in raw data into the field's type. For better performance with Json or Array readers if you are in control of the data fed into this Model, you can null out the default convert function which will cause the raw property to be copied directly into the Field's value.
Now we can create instances of our User model and call any model logic we defined:
var user = Ext.create('User', {
name : 'Conan',
age : 24,
phone: '555-555-5555'
});
user.changeName();
user.get('name'); //returns "Conan The Barbarian"
Validations
Models have built-in support for validations, which are executed against the validator functions in Ext.data.validations (see all validation functions). Validations are easy to add to models:
Ext.define('User', {
extend: 'Ext.data.Model',
fields: [
{name: 'name', type: 'string'},
{name: 'age', type: 'int'},
{name: 'phone', type: 'string'},
{name: 'gender', type: 'string'},
{name: 'username', type: 'string'},
{name: 'alive', type: 'boolean', defaultValue: true}
],
validations: [
{type: 'presence', field: 'age'},
{type: 'length', field: 'name', min: 2},
{type: 'inclusion', field: 'gender', list: ['Male', 'Female']},
{type: 'exclusion', field: 'username', list: ['Admin', 'Operator']},
{type: 'format', field: 'username', matcher: /([a-z]+)[0-9]{2,3}/}
]
});
The validations can be run by simply calling the validate function, which returns a Ext.data.Errors object:
var instance = Ext.create('User', {
name: 'Ed',
gender: 'Male',
username: 'edspencer'
});
var errors = instance.validate();
Associations
Models can have associations with other Models via Ext.data.association.HasOne, belongsTo and hasMany associations. For example, let's say we're writing a blog administration application which deals with Users, Posts and Comments. We can express the relationships between these models like this:
Ext.define('Post', {
extend: 'Ext.data.Model',
fields: ['id', 'user_id'],
belongsTo: 'User',
hasMany : {model: 'Comment', name: 'comments'}
});
Ext.define('Comment', {
extend: 'Ext.data.Model',
fields: ['id', 'user_id', 'post_id'],
belongsTo: 'Post'
});
Ext.define('User', {
extend: 'Ext.data.Model',
fields: ['id'],
hasMany: [
'Post',
{model: 'Comment', name: 'comments'}
]
});
See the docs for Ext.data.association.HasOne, Ext.data.association.BelongsTo and Ext.data.association.HasMany for details on the usage and configuration of associations. Note that associations can also be specified like this:
Ext.define('User', {
extend: 'Ext.data.Model',
fields: ['id'],
associations: [
{type: 'hasMany', model: 'Post', name: 'posts'},
{type: 'hasMany', model: 'Comment', name: 'comments'}
]
});
Using a Proxy
Models are great for representing types of data and relationships, but sooner or later we're going to want to load or save that data somewhere. All loading and saving of data is handled via a Proxy, which can be set directly on the Model:
Ext.define('User', {
extend: 'Ext.data.Model',
fields: ['id', 'name', 'email'],
proxy: {
type: 'rest',
url : '/users'
}
});
Here we've set up a Rest Proxy, which knows how to load and save data to and from a RESTful backend. Let's see how this works:
var user = Ext.create('User', {name: 'Ed Spencer', email: 'ed@sencha.com'});
user.save(); //POST /users
Calling save on the new Model instance tells the configured RestProxy that we wish to persist this Model's data onto our server. RestProxy figures out that this Model hasn't been saved before because it doesn't have an id, and performs the appropriate action - in this case issuing a POST request to the url we configured (/users). We configure any Proxy on any Model and always follow this API - see Ext.data.proxy.Proxy for a full list.
Loading data via the Proxy is equally easy:
//get a reference to the User model class
var User = Ext.ModelManager.getModel('User');
//Uses the configured RestProxy to make a GET request to /users/123
User.load(123, {
success: function(user) {
console.log(user.getId()); //logs 123
}
});
Models can also be updated and destroyed easily:
//the user Model we loaded in the last snippet:
user.set('name', 'Edward Spencer');
//tells the Proxy to save the Model. In this case it will perform a PUT request to /users/123 as this Model already has an id
user.save({
success: function() {
console.log('The User was updated');
}
});
//tells the Proxy to destroy the Model. Performs a DELETE request to /users/123
user.destroy({
success: function() {
console.log('The User was destroyed!');
}
});
Usage in Stores
It is very common to want to load a set of Model instances to be displayed and manipulated in the UI. We do this by creating a Store:
var store = Ext.create('Ext.data.Store', {
model: 'User'
});
//uses the Proxy we set up on Model to load the Store data
store.load();
A Store is just a collection of Model instances - usually loaded from a server somewhere. Store can also maintain a set of added, updated and removed Model instances to be synchronized with the server via the Proxy. See the Store docs for more information on Stores.
Available since: 1.1.0
Config options
An array of associations for this model.
An array of associations for this model.
Available since: 4.0.4
One or more BelongsTo associations for this model.
One or more BelongsTo associations for this model.
Available since: 4.0.4
The name of a property that is used for submitting this Model's unique client-side identifier to the server when multiple phantom records are saved as part of the same Operation. In such a case, the server response should include the client id for each record so that the server response data can be used to update the client-side records if necessary. This property cannot have the same name as any of this Model's fields.
Available since: 4.1.0
The string type of the default Model Proxy. Defaults to 'ajax'.
Defaults to: 'ajax'
Available since: 4.0.4
The fields for this model. This is an Array of Field definition objects. A Field definition may simply be the name of the Field, but a Field encapsulates data type, custom conversion of raw data, and a mapping property to specify by name of index, how to extract a field's value from a raw data object, so it is best practice to specify a full set of Field config objects.
Available since: 4.0.4
One or more HasMany associations for this model.
One or more HasMany associations for this model.
Available since: 4.0.4
The name of the field treated as this Model's unique id. Defaults to 'id'.
Defaults to: 'id'
Available since: 4.0.0
The id generator to use for this model. The default id generator does not generate values for the idProperty.
This can be overridden at the model level to provide a custom generator for a model. The simplest form of this would be:
Ext.define('MyApp.data.MyModel', {
extend: 'Ext.data.Model',
requires: ['Ext.data.SequentialIdGenerator'],
idgen: 'sequential',
...
});
The above would generate sequential id's such as 1, 2, 3 etc..
Another useful id generator is Ext.data.UuidGenerator:
Ext.define('MyApp.data.MyModel', {
extend: 'Ext.data.Model',
requires: ['Ext.data.UuidGenerator'],
idgen: 'uuid',
...
});
An id generation can also be further configured:
Ext.define('MyApp.data.MyModel', {
extend: 'Ext.data.Model',
idgen: {
type: 'sequential',
seed: 1000,
prefix: 'ID_'
}
});
The above would generate id's such as ID_1000, ID_1001, ID_1002 etc..
If multiple models share an id space, a single generator can be shared:
Ext.define('MyApp.data.MyModelX', {
extend: 'Ext.data.Model',
idgen: {
type: 'sequential',
id: 'xy'
}
});
Ext.define('MyApp.data.MyModelY', {
extend: 'Ext.data.Model',
idgen: {
type: 'sequential',
id: 'xy'
}
});
For more complex, shared id generators, a custom generator is the best approach. See Ext.data.IdGenerator for details on creating custom id generators.
Available since: 4.0.5
A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.
DOM events from Ext JS Components
While some Ext JS Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually
only done when extra value can be added. For example the DataView's itemclick event passing the node clicked on. To access DOM events directly from a
child element of a Component, we need to specify the element option to identify the Component property to add a
DOM listener to:
new Ext.panel.Panel({
width: 400,
height: 200,
dockedItems: [{
xtype: 'toolbar'
}],
listeners: {
click: {
element: 'el', //bind to the underlying el property on the panel
fn: function(){ console.log('click el'); }
},
dblclick: {
element: 'body', //bind to the underlying body property on the panel
fn: function(){ console.log('dblclick body'); }
}
}
});
Available since: 1.1.0
The name of the property on this Persistable object that its data is saved to. Defaults to 'data'
(i.e: all persistable data resides in this.data.)
Defaults to: 'data'
Available since: 4.0.2
An array of validations for this model.
An array of validations for this model.
Available since: 4.0.4
Properties
Instance Properties _singleProp : ObjectprivateThis object is used whenever the set() method is called and given a string as the
first argument. ...This object is used whenever the set() method is called and given a string as the
first argument. This approach saves memory (and GC costs) since we could be called
a lot.
Defaults to: {}
Available since: 4.1.0
True if this Record has been modified. ...True if this Record has been modified.
Defaults to: false
Available since: 1.1.0
Internal flag used to track whether or not the model instance is currently being edited. ...Internal flag used to track whether or not the model instance is currently being edited.
Defaults to: false
Available since: 4.0.0
eventsSuspended : NumberprivateInitial suspended call count. ...Initial suspended call count. Incremented when suspendEvents is called, decremented when resumeEvents is called.
Defaults to: 0
Available since: 4.1.1
A Collection of the fields defined for this Model (including fields defined in superclasses)
This is a collection of...A Collection of the fields defined for this Model (including fields defined in superclasses)
This is a collection of Ext.data.Field instances, each of which encapsulates information that the field was configured with.
By default, you can specify a field as simply a String, representing the name of the field, but a Field encapsulates
data type, custom conversion of raw data, and a mapping
property to specify by name of index, how to extract a field's value from a raw data object.
Available since: 2.3.0
hasListeners : ObjectreadonlyThis object holds a key for any event that has a listener. ...This object holds a key for any event that has a listener. The listener may be set
directly on the instance, or on its class or a super class (via observe) or
on the MVC EventBus. The values of this object are truthy
(a non-zero number) and falsy (0 or undefined). They do not represent an exact count
of listeners. The value for an event is truthy if the event must be fired and is
falsy if there is no need to fire the event.
The intended use of this property is to avoid the expense of fireEvent calls when
there are no listeners. This can be particularly helpful when one would otherwise
have to call fireEvent hundreds or thousands of times. It is used like this:
if (this.hasListeners.foo) {
this.fireEvent('foo', this, arg1);
}
Available since: 4.1.0
internalId : Number/StringprivateAn internal unique ID for each Model instance, used to identify Models that don't have an ID yet
An internal unique ID for each Model instance, used to identify Models that don't have an ID yet
Available since: 4.0.0
true in this class to identify an object as an instantiated Model, or subclass thereof. ...true in this class to identify an object as an instantiated Model, or subclass thereof.
Defaults to: true
Available since: 4.0.0
true in this class to identify an object as an instantiated Observable, or subclass thereof. ...true in this class to identify an object as an instantiated Observable, or subclass thereof.
Defaults to: true
Available since: 4.0.0
Key: value pairs of all fields whose values have changed
Key: value pairs of all fields whose values have changed
Available since: 2.3.0
True when the record does not yet exist in a server-side database (see setDirty). ...True when the record does not yet exist in a server-side database (see setDirty).
Any record which has a real database pk set as its id property is NOT a phantom -- it's real.
Defaults to: false
Available since: 3.4.0
The raw data used to create this model if created via a reader.
The raw data used to create this model if created via a reader.
Available since: 4.0.1
Get the reference to the current class from which this object was instantiated. ...Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); // dependent on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 4.0.0
stores : Ext.data.Store[]
This object is used whenever the set() method is called and given a string as the first argument. This approach saves memory (and GC costs) since we could be called a lot.
Defaults to: {}
Available since: 4.1.0
True if this Record has been modified.
Defaults to: false
Available since: 1.1.0
Internal flag used to track whether or not the model instance is currently being edited.
Defaults to: false
Available since: 4.0.0
Initial suspended call count. Incremented when suspendEvents is called, decremented when resumeEvents is called.
Defaults to: 0
Available since: 4.1.1
A Collection of the fields defined for this Model (including fields defined in superclasses)
This is a collection of Ext.data.Field instances, each of which encapsulates information that the field was configured with. By default, you can specify a field as simply a String, representing the name of the field, but a Field encapsulates data type, custom conversion of raw data, and a mapping property to specify by name of index, how to extract a field's value from a raw data object.
Available since: 2.3.0
This object holds a key for any event that has a listener. The listener may be set directly on the instance, or on its class or a super class (via observe) or on the MVC EventBus. The values of this object are truthy (a non-zero number) and falsy (0 or undefined). They do not represent an exact count of listeners. The value for an event is truthy if the event must be fired and is falsy if there is no need to fire the event.
The intended use of this property is to avoid the expense of fireEvent calls when there are no listeners. This can be particularly helpful when one would otherwise have to call fireEvent hundreds or thousands of times. It is used like this:
if (this.hasListeners.foo) {
this.fireEvent('foo', this, arg1);
}
Available since: 4.1.0
An internal unique ID for each Model instance, used to identify Models that don't have an ID yet
An internal unique ID for each Model instance, used to identify Models that don't have an ID yet
Available since: 4.0.0
true in this class to identify an object as an instantiated Model, or subclass thereof.
Defaults to: true
Available since: 4.0.0
true in this class to identify an object as an instantiated Observable, or subclass thereof.
Defaults to: true
Available since: 4.0.0
Key: value pairs of all fields whose values have changed
Key: value pairs of all fields whose values have changed
Available since: 2.3.0
True when the record does not yet exist in a server-side database (see setDirty). Any record which has a real database pk set as its id property is NOT a phantom -- it's real.
Defaults to: false
Available since: 3.4.0
The raw data used to create this model if created via a reader.
The raw data used to create this model if created via a reader.
Available since: 4.0.1
Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); // dependent on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 4.0.0
Static Properties The update operation of type 'commit'. ...The update operation of type 'commit'. Used by Store.update event.
Defaults to: 'commit'
Available since: 4.1.1
The update operation of type 'edit'. ...The update operation of type 'edit'. Used by Store.update event.
Defaults to: 'edit'
Available since: 4.1.1
The update operation of type 'reject'. ...The update operation of type 'reject'. Used by Store.update event.
Defaults to: 'reject'
Available since: 4.1.1
The update operation of type 'commit'. Used by Store.update event.
Defaults to: 'commit'
Available since: 4.1.1
The update operation of type 'edit'. Used by Store.update event.
Defaults to: 'edit'
Available since: 4.1.1
The update operation of type 'reject'. Used by Store.update event.
Defaults to: 'reject'
Available since: 4.1.1
Methods
Instance Methods Creates new Model instance. ...Creates new Model instance.
Available since: 1.1.0
Parameters
- data : Object
An object containing keys corresponding to this model's fields, and their associated values
Returns
addEvents( eventNames )Adds the specified events to the list of events which this Observable may fire. ...Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
Appends an event handler to this object. ...Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object
containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for.
May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if scope is specified, the name* of the method within
the specified scope. Will be called with arguments
given to fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is
executed. If omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last
argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (this reference) in which the handler function is executed. If omitted,
defaults to the object which fired the event.
- delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed
by the specified number of milliseconds. If the event fires again within that time,
the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event
was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components.
The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
- destroyable : Boolean (optional)
When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Defaults to: false
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.on({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
Overrides: Ext.AbstractComponent.addListener
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destr...Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- options : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.mon({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
afterCommit( )private afterEdit( modifiedFieldNames )private afterReject( )private beginEdit( )Begins an edit. ...Begins an edit. While in edit mode, no events (e.g.. the update event) are relayed to the containing store.
When an edit has begun, it must be followed by either endEdit or cancelEdit.
Available since: 2.3.0
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: functi...Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callOverridden();
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
This method has been deprecated
as of 4.1. Use callParent instead.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. ...Call the "parent" method of the current method. That is the method previously
overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
To override a method and replace it and also call the superclass method, use
callSuper. This is often done to patch a method to fix a bug.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
callStore( fn )privateHelper function used by afterEdit, afterReject and afterCommit. ...Helper function used by afterEdit, afterReject and afterCommit. Calls the given method on the
store that this instance has joined, if any. The store function
will always be called with the model instance as its single argument. If this model is joined to
a Ext.data.NodeStore, then this method calls the given method on the NodeStore and the associated Ext.data.TreeStore
Available since: 4.0.0
Parameters
- fn : String
The function to call on the store
This method is used by an override to call the superclass method but bypass any
overridden method. ...This method is used by an override to call the superclass method but bypass any
overridden method. This is often done to "patch" a method that contains a bug
but for whatever reason cannot be fixed directly.
Consider:
Ext.define('Ext.some.Class', {
method: function () {
console.log('Good');
}
});
Ext.define('Ext.some.DerivedClass', {
method: function () {
console.log('Bad');
// ... logic but with a bug ...
this.callParent();
}
});
To patch the bug in DerivedClass.method, the typical solution is to create an
override:
Ext.define('App.paches.DerivedClass', {
override: 'Ext.some.DerivedClass',
method: function () {
console.log('Fixed');
// ... logic but with bug fixed ...
this.callSuper();
}
});
The patch method cannot use callParent to call the superclass method since
that would call the overridden method containing the bug. In other words, the
above patch would only produce "Fixed" then "Good" in the console log, whereas,
using callParent would produce "Fixed" then "Bad" then "Good".
Available since: Ext JS 4.1.3
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callSuper(arguments)
Returns
- Object
Returns the result of calling the superclass method
cancelEdit( )Cancels all changes made in the current edit operation. ...Cancels all changes made in the current edit operation.
Available since: 2.3.0
Removes all listeners for this object including the managed listeners ...Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object. ...Removes all managed listeners for this object.
Available since: 4.0.0
commit( [silent] )Usually called by the Ext.data.Store which owns the model instance. ...Usually called by the Ext.data.Store which owns the model instance. Commits all changes made to the
instance since either creation or the last commit operation.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of commit
operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change.
Defaults to false.
continueFireEvent( eventName, args, bubbles )private Creates a copy (clone) of this Model instance. ...Creates a copy (clone) of this Model instance.
Available since: 1.1.0
Parameters
- id : String (optional)
A new id, defaults to the id of the instance being copied.
See id. To generate a phantom instance with a new id use:
var rec = record.copy(); // clone the record
Ext.data.Model.id(rec); // automatically generate a unique sequential id
Returns
copyFrom( sourceRecord )privateCopies data from the passed record into this record. ...Copies data from the passed record into this record. If the passed record is undefined, does nothing.
If this is a phantom record (represented only in the client, with no corresponding database entry), and
the source record is not a phantom, then this record acquires the id of the source record.
Available since: 4.1.0
Parameters
- sourceRecord : Ext.data.Model
The record to copy data from.
Creates an event handling function which refires the event from this object as the passed event name. ... Destroys the model using the configured proxy. ...Destroys the model using the configured proxy.
Available since: 4.0.0
Parameters
- options : Object
Options to pass to the proxy. Config object for Ext.data.Operation.
Returns
- Ext.data.Model
The Model instance
Overrides: Ext.Base.destroy
enableBubble( eventNames )Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. ...Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers.
See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the
Component's immediate owner. But if a known target is required, this can be overridden to access the
required target more quickly.
Example:
Ext.define('Ext.overrides.form.field.Base', {
override: 'Ext.form.field.Base',
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent: function () {
this.callParent();
this.enableBubble('change');
}
});
var myForm = Ext.create('Ext.form.Panel', {
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
endEdit( silent, modifiedFieldNames ) Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addList...Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by
calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
getAssociatedData( ) : ObjectGets all of the data from this Models loaded associations. ...Gets all of the data from this Models loaded associations. It does this recursively - for example if we have a
User which hasMany Orders, and each Order hasMany OrderItems, it will return an object like this:
{
orders: [
{
id: 123,
status: 'shipped',
orderItems: [
...
]
}
]
}
Available since: 4.0.0
Returns
- Object
The nested data set for the Model's loaded associations
getBubbleParent( ) : Ext.util.ObservableprivateGets the bubbling parent for an Observable ...Gets the bubbling parent for an Observable
Available since: 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
getChanges( ) : ObjectGets a hash of only the fields that have been modified since this Model was created or commited. ...Gets a hash of only the fields that have been modified since this Model was created or commited.
Available since: 2.3.0
Returns
Returns the unique ID allocated to this model instance as defined by idProperty. ...Returns the unique ID allocated to this model instance as defined by idProperty.
Available since: 4.0.0
Returns
Returns the configured Proxy for this Model. ...Returns the configured Proxy for this Model.
Available since: 4.0.0
Returns
- Ext.data.proxy.Proxy
The proxy
Checks to see if this object has any listeners for a specified event, or whether the event bubbles. ...Checks to see if this object has any listeners for a specified event, or whether the event bubbles. The answer
indicates whether the event needs firing or not.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to check for
Returns
- Boolean
true if the event is being listened for or bubbles, else false
Initialize configuration for this class. ...Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Ext.Base
this
join( store )Tells this model instance that it has been added to a store. ...Tells this model instance that it has been added to a store.
Available since: 4.0.0
Parameters
- store : Ext.data.Store
The store to which this model has been added.
Shorthand for addManagedListener. ...Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- options : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.mon({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
mun( item, ename, [fn], [scope] )Shorthand for removeManagedListener. ...Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
Shorthand for addListener. ...Shorthand for addListener.
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object
containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for.
May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if scope is specified, the name* of the method within
the specified scope. Will be called with arguments
given to fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is
executed. If omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last
argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (this reference) in which the handler function is executed. If omitted,
defaults to the object which fired the event.
- delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed
by the specified number of milliseconds. If the event fires again within that time,
the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event
was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components.
The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
- destroyable : Boolean (optional)
When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Defaults to: false
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.on({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
onClassExtended( cls, data, hooks )private onConfigUpdate( names, callback, scope )private This complex-looking method takes a given Model instance and returns an object containing all data from
all of that M...This complex-looking method takes a given Model instance and returns an object containing all data from
all of that Model's loaded associations. See getAssociatedData
Available since: 4.0.0
Parameters
Returns
- Object
The nested data set for the Model's loaded associations
prepareClass( T )privatePrepares a given class for observable instances. ...Prepares a given class for observable instances. This method is called when a
class derives from this class or uses this class as a mixin.
Available since: 4.1.0
Parameters
- T : Function
The class constructor to prepare.
reject( [silent] )Usually called by the Ext.data.Store to which this model instance has been joined. ...Usually called by the Ext.data.Store to which this model instance has been joined. Rejects
all changes made to the model instance since either creation, or the last commit operation. Modified fields are
reverted to their original values.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of reject
operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change.
Defaults to false.
Relays selected events from the specified Observable as if the events were fired by this. ...Relays selected events from the specified Observable as if the events were fired by this.
For example if you are extending Grid, you might decide to forward some events from store.
So you can do this inside your initComponent:
this.relayEvents(this.getStore(), ['load']);
The grid instance will then have an observable 'load' event which will be passed the
parameters of the store's load event and any function fired with the grid's load event
would have access to the grid using the this keyword.
Available since: 2.3.0
Parameters
- origin : Object
The Observable whose events this object is to relay.
- events : String[]
Array of event names to relay.
- prefix : String (optional)
A common prefix to prepend to the event names. For example:
this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
Now the grid will forward 'load' and 'clear' events of store as 'storeload' and 'storeclear'.
Returns
- Object
A Destroyable object. An object which implements the destroy method which, when destroyed, removes all relayers. For example:
this.storeRelayers = this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
Can be undone by calling
Ext.destroy(this.storeRelayers);
or
this.store.relayers.destroy();
removeListener( eventName, fn, [scope] )Removes an event handler. ...Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
removeManagedListener( item, ename, [fn], [scope] )Removes listeners that were added by the mon method. ...Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
removeManagedListenerItem( isClear, managedListener )private resumeEvents( )Resumes firing events (see suspendEvents). ...Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
Saves the model instance using the configured proxy. ...Saves the model instance using the configured proxy.
Available since: 4.0.0
Parameters
- options : Object
Options to pass to the proxy. Config object for Ext.data.Operation.
Returns
- Ext.data.Model
The Model instance
Sets the given field to the given value, marks the instance as dirty ...Sets the given field to the given value, marks the instance as dirty
Available since: 1.1.0
Parameters
- fieldName : String/Object
The field to set, or an object containing key/value pairs
- newValue : Object
The value to set
Returns
- String[]
The array of modified field names or null if nothing was modified.
setDirty( )Marks this Record as dirty. ...Marks this Record as dirty. This method is used interally when adding phantom records
to a writer enabled store.
Marking a record dirty causes the phantom to be returned by Ext.data.Store.getUpdatedRecords
where it will have a create action composed for it during model save operations.
Available since: 4.0.0
setId( id ) Sets the Proxy to use for this model. ...Sets the Proxy to use for this model. Accepts any options that can be accepted by
Ext.createByAlias.
Available since: 4.0.4
Parameters
- proxy : String/Object/Ext.data.proxy.Proxy
The proxy
Returns
Get the reference to the class from which this object was instantiated. ...Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
suspendEvents( queueSuspended )Suspends the firing of all events. ...Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired
after the resumeEvents call instead of discarding all suspended events.
un( eventName, fn, [scope] )Shorthand for removeListener. ...Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
unjoin( store )Tells this model instance that it has been removed from the store. ...Tells this model instance that it has been removed from the store.
Available since: 4.0.0
Parameters
- store : Ext.data.Store
The store from which this model has been removed.
validate( ) : Ext.data.ErrorsValidates the current data against all of its configured validations. ...Validates the current data against all of its configured validations.
Available since: 4.0.0
Returns
- Ext.data.Errors
The errors object
Creates new Model instance.
Available since: 1.1.0
Parameters
- data : Object
An object containing keys corresponding to this model's fields, and their associated values
Returns
Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if
scopeis specified, the name* of the method within the specifiedscope. Will be called with arguments given to fireEvent plus theoptionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } }); - destroyable : Boolean (optional)
When specified as
true, the function returns ADestroyableobject. An object which implements thedestroymethod which removes all listeners added in this call.Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Defaults to:
false
- scope : Object
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.on({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Overrides: Ext.AbstractComponent.addListener
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - options : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.mon({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Begins an edit. While in edit mode, no events (e.g.. the update event) are relayed to the containing store.
When an edit has begun, it must be followed by either endEdit or cancelEdit.
Available since: 2.3.0
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callOverridden();
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
This method has been deprecated
as of 4.1. Use callParent instead.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. That is the method previously overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
To override a method and replace it and also call the superclass method, use callSuper. This is often done to patch a method to fix a bug.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
Helper function used by afterEdit, afterReject and afterCommit. Calls the given method on the store that this instance has joined, if any. The store function will always be called with the model instance as its single argument. If this model is joined to a Ext.data.NodeStore, then this method calls the given method on the NodeStore and the associated Ext.data.TreeStore
Available since: 4.0.0
Parameters
- fn : String
The function to call on the store
This method is used by an override to call the superclass method but bypass any overridden method. This is often done to "patch" a method that contains a bug but for whatever reason cannot be fixed directly.
Consider:
Ext.define('Ext.some.Class', {
method: function () {
console.log('Good');
}
});
Ext.define('Ext.some.DerivedClass', {
method: function () {
console.log('Bad');
// ... logic but with a bug ...
this.callParent();
}
});
To patch the bug in DerivedClass.method, the typical solution is to create an
override:
Ext.define('App.paches.DerivedClass', {
override: 'Ext.some.DerivedClass',
method: function () {
console.log('Fixed');
// ... logic but with bug fixed ...
this.callSuper();
}
});
The patch method cannot use callParent to call the superclass method since
that would call the overridden method containing the bug. In other words, the
above patch would only produce "Fixed" then "Good" in the console log, whereas,
using callParent would produce "Fixed" then "Bad" then "Good".
Available since: Ext JS 4.1.3
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callSuper(arguments)
Returns
- Object
Returns the result of calling the superclass method
Cancels all changes made in the current edit operation.
Available since: 2.3.0
Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object.
Available since: 4.0.0
Usually called by the Ext.data.Store which owns the model instance. Commits all changes made to the instance since either creation or the last commit operation.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of commit operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change. Defaults to false.
Creates a copy (clone) of this Model instance.
Available since: 1.1.0
Parameters
- id : String (optional)
A new id, defaults to the id of the instance being copied. See
id. To generate a phantom instance with a new id use:var rec = record.copy(); // clone the record Ext.data.Model.id(rec); // automatically generate a unique sequential id
Returns
Copies data from the passed record into this record. If the passed record is undefined, does nothing.
If this is a phantom record (represented only in the client, with no corresponding database entry), and the source record is not a phantom, then this record acquires the id of the source record.
Available since: 4.1.0
Parameters
- sourceRecord : Ext.data.Model
The record to copy data from.
Destroys the model using the configured proxy.
Available since: 4.0.0
Parameters
- options : Object
Options to pass to the proxy. Config object for Ext.data.Operation.
Returns
- Ext.data.Model
The Model instance
Overrides: Ext.Base.destroy
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.
Example:
Ext.define('Ext.overrides.form.field.Base', {
override: 'Ext.form.field.Base',
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent: function () {
this.callParent();
this.enableBubble('change');
}
});
var myForm = Ext.create('Ext.form.Panel', {
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
Gets all of the data from this Models loaded associations. It does this recursively - for example if we have a User which hasMany Orders, and each Order hasMany OrderItems, it will return an object like this:
{
orders: [
{
id: 123,
status: 'shipped',
orderItems: [
...
]
}
]
}
Available since: 4.0.0
Returns
- Object
The nested data set for the Model's loaded associations
Gets the bubbling parent for an Observable
Available since: 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
Gets a hash of only the fields that have been modified since this Model was created or commited.
Available since: 2.3.0
Returns
Returns the unique ID allocated to this model instance as defined by idProperty.
Available since: 4.0.0
Returns
Returns the configured Proxy for this Model.
Available since: 4.0.0
Returns
- Ext.data.proxy.Proxy
The proxy
Checks to see if this object has any listeners for a specified event, or whether the event bubbles. The answer indicates whether the event needs firing or not.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to check for
Returns
- Boolean
trueif the event is being listened for or bubbles, elsefalse
Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Ext.Base
this
Tells this model instance that it has been added to a store.
Available since: 4.0.0
Parameters
- store : Ext.data.Store
The store to which this model has been added.
Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - options : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.mon({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Shorthand for addListener.
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if
scopeis specified, the name* of the method within the specifiedscope. Will be called with arguments given to fireEvent plus theoptionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } }); - destroyable : Boolean (optional)
When specified as
true, the function returns ADestroyableobject. An object which implements thedestroymethod which removes all listeners added in this call.Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Defaults to:
false
- scope : Object
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.on({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
This complex-looking method takes a given Model instance and returns an object containing all data from all of that Model's loaded associations. See getAssociatedData
Available since: 4.0.0
Parameters
Returns
- Object
The nested data set for the Model's loaded associations
Prepares a given class for observable instances. This method is called when a class derives from this class or uses this class as a mixin.
Available since: 4.1.0
Parameters
- T : Function
The class constructor to prepare.
Usually called by the Ext.data.Store to which this model instance has been joined. Rejects all changes made to the model instance since either creation, or the last commit operation. Modified fields are reverted to their original values.
Developers should subscribe to the Ext.data.Store.update event to have their code notified of reject operations.
Available since: 1.1.0
Parameters
- silent : Boolean (optional)
True to skip notification of the owning store of the change. Defaults to false.
Relays selected events from the specified Observable as if the events were fired by this.
For example if you are extending Grid, you might decide to forward some events from store. So you can do this inside your initComponent:
this.relayEvents(this.getStore(), ['load']);
The grid instance will then have an observable 'load' event which will be passed the
parameters of the store's load event and any function fired with the grid's load event
would have access to the grid using the this keyword.
Available since: 2.3.0
Parameters
- origin : Object
The Observable whose events this object is to relay.
- events : String[]
Array of event names to relay.
- prefix : String (optional)
A common prefix to prepend to the event names. For example:
this.relayEvents(this.getStore(), ['load', 'clear'], 'store');Now the grid will forward 'load' and 'clear' events of store as 'storeload' and 'storeclear'.
Returns
- Object
A
Destroyableobject. An object which implements thedestroymethod which, when destroyed, removes all relayers. For example:this.storeRelayers = this.relayEvents(this.getStore(), ['load', 'clear'], 'store');Can be undone by calling
Ext.destroy(this.storeRelayers);or
this.store.relayers.destroy();
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
Saves the model instance using the configured proxy.
Available since: 4.0.0
Parameters
- options : Object
Options to pass to the proxy. Config object for Ext.data.Operation.
Returns
- Ext.data.Model
The Model instance
Sets the given field to the given value, marks the instance as dirty
Available since: 1.1.0
Parameters
- fieldName : String/Object
The field to set, or an object containing key/value pairs
- newValue : Object
The value to set
Returns
- String[]
The array of modified field names or null if nothing was modified.
Marks this Record as dirty. This method is used interally when adding phantom records
to a writer enabled store.
Marking a record dirty causes the phantom to be returned by Ext.data.Store.getUpdatedRecords
where it will have a create action composed for it during model save operations.
Available since: 4.0.0
Sets the Proxy to use for this model. Accepts any options that can be accepted by Ext.createByAlias.
Available since: 4.0.4
Parameters
- proxy : String/Object/Ext.data.proxy.Proxy
The proxy
Returns
Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events.
Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Tells this model instance that it has been removed from the store.
Available since: 4.0.0
Parameters
- store : Ext.data.Store
The store from which this model has been removed.
Validates the current data against all of its configured validations.
Available since: 4.0.0
Returns
- Ext.data.Errors
The errors object
Static Methods addMember( name, member )chainableprivatestatic addMembers( members )chainablestaticAdd methods / properties to the prototype of this class. ...Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.addMembers({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.1.0
Parameters
- members : Object
Add / override static properties of this class. ...Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class. ...Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class. ...Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
createAlias( alias, origin )staticCreate aliases for existing prototype methods. ...Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See
flexSetter
- origin : String/Object
The original method name
getFields( ) : Ext.data.Field[]staticReturns an Array of Field definitions which define this Model's structure
Fields are sorted upon Model class definit...Returns an Array of Field definitions which define this Model's structure
Fields are sorted upon Model class definition. Fields with custom convert functions
are moved to after fields with no convert functions. This is so that convert functions which rely on existing
field values will be able to read those field values.
Available since: 4.1.0
Returns
- Ext.data.Field[]
The defined Fields for this Model.
Get the current class' name in string format. ...Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
getProxy( ) : Ext.data.proxy.ProxystaticReturns the configured Proxy for this Model ...Returns the configured Proxy for this Model
Available since: 4.0.4
Returns
- Ext.data.proxy.Proxy
The proxy
Generates a sequential id. ...Generates a sequential id. This method is typically called when a record is created and no id has been specified. The id will automatically be assigned to the
record. The returned id takes the form: {PREFIX}-{AUTO_ID}.
- PREFIX : String - Ext.data.Model.PREFIX (defaults to 'ext-record')
- AUTO_ID : String - Ext.data.Model.AUTO_ID (defaults to 1 initially)
Available since: 4.0.0
Parameters
- rec : Ext.data.Model
The record being created. The record does not exist, it's a phantom.
Returns
- String
auto-generated string id, "ext-record-i++";
implement( )deprecatedstaticAdds members to class. ...Adds members to class.
This method has been deprecated since 4.1
Use addMembers instead.
Available since: 4.0.2
load( id, [config] )staticAsynchronously loads a model instance by id. ...Asynchronously loads a model instance by id. Sample usage:
Ext.define('MyApp.User', {
extend: 'Ext.data.Model',
fields: [
{name: 'id', type: 'int'},
{name: 'name', type: 'string'}
]
});
MyApp.User.load(10, {
scope: this,
failure: function(record, operation) {
//do something if the load failed
},
success: function(record, operation) {
//do something if the load succeeded
},
callback: function(record, operation) {
//do something whether the load succeeded or failed
}
});
Available since: 4.0.0
Parameters
mixin( name, mixinClass )chainableprivatestatic onExtended( fn, scope )chainableprivatestatic Override members of this class. ...Override members of this class. Overridden methods can be invoked via
callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define
instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
The above accomplishes the same result but can be managed by the Ext.Loader
which can properly order the override and its target class and the build process
can determine whether the override is needed based on the required state of the
target class (My.Cat).
This method has been deprecated since 4.1.0
Use Ext.define instead
Available since: 4.0.2
Parameters
- members : Object
The properties to add to this class. This should be
specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class
setFields( fields, idProperty, clientIdProperty )staticApply a new set of field and/or property definitions to the existing model. ...Apply a new set of field and/or property definitions to the existing model. This will replace any existing
fields, including fields inherited from superclasses. Mainly for reconfiguring the
model based on changes in meta data (called from Reader's onMetaChange method).
Available since: 4.1.0
Parameters
Sets the Proxy to use for this model. ...Sets the Proxy to use for this model. Accepts any options that can be accepted by
Ext.createByAlias.
Available since: 4.0.0
Parameters
- proxy : String/Object/Ext.data.proxy.Proxy
The proxy
Returns
Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.addMembers({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.1.0
Parameters
- members : Object
Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See flexSetter
- origin : String/Object
The original method name
Returns an Array of Field definitions which define this Model's structure
Fields are sorted upon Model class definition. Fields with custom convert functions are moved to after fields with no convert functions. This is so that convert functions which rely on existing field values will be able to read those field values.
Available since: 4.1.0
Returns
- Ext.data.Field[]
The defined Fields for this Model.
Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
Returns the configured Proxy for this Model
Available since: 4.0.4
Returns
- Ext.data.proxy.Proxy
The proxy
Generates a sequential id. This method is typically called when a record is created and no id has been specified. The id will automatically be assigned to the record. The returned id takes the form: {PREFIX}-{AUTO_ID}.
- PREFIX : String - Ext.data.Model.PREFIX (defaults to 'ext-record')
- AUTO_ID : String - Ext.data.Model.AUTO_ID (defaults to 1 initially)
Available since: 4.0.0
Parameters
- rec : Ext.data.Model
The record being created. The record does not exist, it's a phantom.
Returns
- String
auto-generated string id,
"ext-record-i++";
Adds members to class.
This method has been deprecated since 4.1
Use addMembers instead.
Available since: 4.0.2
Asynchronously loads a model instance by id. Sample usage:
Ext.define('MyApp.User', {
extend: 'Ext.data.Model',
fields: [
{name: 'id', type: 'int'},
{name: 'name', type: 'string'}
]
});
MyApp.User.load(10, {
scope: this,
failure: function(record, operation) {
//do something if the load failed
},
success: function(record, operation) {
//do something if the load succeeded
},
callback: function(record, operation) {
//do something whether the load succeeded or failed
}
});
Available since: 4.0.0
Parameters
Override members of this class. Overridden methods can be invoked via callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
The above accomplishes the same result but can be managed by the Ext.Loader which can properly order the override and its target class and the build process can determine whether the override is needed based on the required state of the target class (My.Cat).
This method has been deprecated since 4.1.0
Use Ext.define instead
Available since: 4.0.2
Parameters
- members : Object
The properties to add to this class. This should be specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class
Apply a new set of field and/or property definitions to the existing model. This will replace any existing fields, including fields inherited from superclasses. Mainly for reconfiguring the model based on changes in meta data (called from Reader's onMetaChange method).
Available since: 4.1.0
Parameters
Sets the Proxy to use for this model. Accepts any options that can be accepted by Ext.createByAlias.
Available since: 4.0.0
Parameters
- proxy : String/Object/Ext.data.proxy.Proxy
The proxy
Returns
Events
Fired when this model's id changes
Available since: 4.1.0
Parameters
- this : Ext.data.Model
- oldId : Number/String
The old id
- newId : Number/String
The new id
- eOpts : Object
The options object passed to Ext.util.Observable.addListener.